<?php
require_once(dirname(__FILE__) . '/../../config/config.inc.php');

require_once(dirname(__FILE__) . '/traknpay.php');

$logger = new FileLogger(0); //0 == debug level, logDebug() won’t work without this.
$logger->setFilename(_PS_ROOT_DIR_ . "/log/tnp.log");
$is_logged_in = Context::getContext()->customer->isLogged();

/*foreach ($_POST as $key => $value)
    echo "Field ".htmlspecialchars($key)." is ".htmlspecialchars($value)."<br>";*/


//die();

$traknpay = new Traknpay();
$salt = Configuration::get('TRAKNPAY_PRIVATE_SALT');
$order_id = $_POST["udf1"];
$response_code = $_POST["response_code"];
$transaction_id = $_POST["transaction_id"];
$amount = $_POST["amount"];
$response_message =$_POST['response_message'];

$hash_columns = $_POST;
unset($hash_columns['hash']);

ksort($hash_columns);

$hash_data = $salt;

foreach ($hash_columns as $key=>$value) {
    if (strlen($value) > 0) {
        $hash_data .= '|' . $value;
    }
}
$hash = null;

if (strlen($hash_data) > 0) {
    $hash = strtoupper(hash('sha512', $hash_data));
}

$cart = new Cart($order_id);
$customer = new Customer((int)$cart->id_customer);
$extra_vars = array('transaction_id' => $transaction_id);
$traknpay->updateOrderIdStatus($_POST["order_id"],$_POST["udf1"]);

if ($hash == $_POST['hash']) {
    if ($response_code == 0) {
        $extra_vars['reason'] = "Payment successful";
        $logger->logDebug("Payment ₹$amount is successful for TNP Order Id ".$_POST["order_id"]." , Cart Id $order_id and Transaction Id $transaction_id.");
        $traknpay->validateOrder((int)$cart->id, _PS_OS_PAYMENT_, $amount, $traknpay->displayName, NULL, $extra_vars, NULL, false, $customer->secure_key, NULL);
        $result = Db::getInstance()->getRow('SELECT * FROM ' . _DB_PREFIX_ . 'orders WHERE id_cart = ' . (int)$order_id);

        if ($is_logged_in) {
            Tools::redirectLink(_PS_BASE_URL_ . __PS_BASE_URI__ . 'index.php?controller=order-detail&id_order=' . $result['id_order']);
        } else {
            $logger->logDebug("User is a guest user.");
            Tools::redirectLink(_PS_BASE_URL_ . __PS_BASE_URI__ . 'index.php?controller=guest-tracking' . '&id_order=' . $result['reference'] . '&email=' . urlencode($customer->email));
        }
    }elseif ($response_message == 'Transaction Failed'){
        $logger->logDebug("Payment unsuccessful for TNP Order Id ".$_POST["order_id"]." and Cart Id $order_id .");
        $extra_vars['reason'] = "Payment failed";
        $traknpay->validateOrder((int)$cart->id, _PS_OS_ERROR_, $amount, $traknpay->displayName, NULL, $extra_vars, NULL, false, $customer->secure_key, NULL);
        include(dirname(__FILE__).'/../../header.php');
        $smarty->assign('cartId', $order_id);
        $smarty->assign('baseUrl', _PS_BASE_URL_.__PS_BASE_URI__);
        $smarty->display('failure.tpl');
        include(dirname(__FILE__).'/../../footer.php');
    }
    else {
        include(dirname(__FILE__).'/../../header.php');
        $response_message=substr($response_message,strpos($response_message, ' - ')+2);
        $smarty->assign('error', $response_message);
        $smarty->assign('baseUrl', _PS_BASE_URL_.__PS_BASE_URI__);
        $smarty->display('error.tpl');
        include(dirname(__FILE__).'/../../footer.php');
    }
} else {
    $logger->logDebug("Hash mis matched.");
    $logger->logDebug("Hash Calculated with data sent by server is : $hash_data");
    $logger->logDebug("Hash Calculated  : " . $hash);
    $logger->logDebug("Hash from the server is : " . $_POST['hash']);
    $extra_vars['reason'] = "Hash mis matched";
    $traknpay->validateOrder((int)$cart->id, _PS_OS_ERROR_, $amount, $traknpay->displayName, NULL, $extra_vars, NULL, false, $customer->secure_key, NULL);
    Tools::redirectLink(_PS_BASE_URL_ . __PS_BASE_URI__ . 'index.php?controller=history');
}

?>
